# Add to a batch

Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Add a shipment or rate to a batch.

Endpoint: POST /v2/batches/{batch_id}/add
Version: 2.0.0
Security: api_keys

## Path parameters:

  - `batch_id` (string, required)
    Batch ID
    Example: "se-28529731"

## Request fields (application/json):

  - `external_batch_id` (string)
    A string that uniquely identifies the external batch
    Example: "se-28529731"

  - `batch_notes` (string)
    Add custom messages for a particular batch
    Example: "This is my batch"

  - `shipment_ids` (array)
    Array of shipment IDs used in the batch
    Example: ["se-28529731"]

  - `rate_ids` (array)
    Array of rate IDs used in the batch
    Example: ["se-28529731"]

  - `process_labels` (object)
    The information used to process the batch

  - `process_labels.create_batch_and_process_labels` (boolean)
    When 'true', the batch will be enqueued for processing
    Example: true

  - `process_labels.ship_date` (string)
    The Ship date the batch is being processed for
    Example: "2018-09-23T15:00:00.000Z"

  - `process_labels.label_layout` (string)
    The available layouts (sizes) in which shipping labels can be downloaded.  The label format determines which sizes are supported.  4x6 is supported for all label formats, whereas letter (8.5" x 11") is only supported for pdf format.
    Enum: "4x6", "letter"

  - `process_labels.label_format` (string)
    The possible file formats in which shipping labels can be downloaded.  We recommend pdf format because it is supported by all carriers, whereas some carriers do not support the png or zpl formats.

|Label Format  | Supported Carriers
|--------------|-----------------------------------
|pdf         | All carriers
|png         | fedex  stamps_com  ups  usps
|zpl         | access_worldwide  apc  asendia  dhl_global_mail  dhl_express  dhl_express_australia  dhl_express_canada  dhl_express_worldwide  dhl_express_uk  dpd  endicia  fedex  fedex_uk  firstmile  imex  newgistics  ontrac  rr_donnelley  stamps_com  ups  usps
    Enum: "pdf", "png", "zpl"

  - `process_labels.display_scheme` (string)
    The display format that the label should be shown in.
    Enum: "label", "paperless", "label_and_paperless"

## Response 400 fields (application/json):

  - `request_id` (string, required)
    A UUID that uniquely identifies the request id.
This can be given to the support team to help debug non-trivial issues that may occur
    Example: "aa3d8e8e-462b-4476-9618-72db7f7b7009"

  - `errors` (array, required)
    The errors associated with the failed API call

  - `errors.error_source` (string, required)
    The source of the error, as indicated by the name this informs us if the API call failed because of the
carrier, the order source, the ShipStation API itself, or the underlying ShipEngine platform.
    Enum: "carrier", "order_source", "ShipStation", "shipengine"

  - `errors.error_type` (string, required)
    The type of error
    Enum: "account_status", "business_rules", "validation", "security", "system", "integrations"

  - `errors.error_code` (string, required)
    The error code specified for the failed API Call
    Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned"

  - `errors.message` (string, required)
    An error message associated with the failed API call
    Example: "Body of request cannot be null."

  - `errors.field_name` (string)
    The name of the field that caused the error (only present for validation errors)
    Example: "inventory_warehouse_id"

  - `errors.field_value` (string)
    The invalid value that was provided for the field (only present for validation errors)
    Example: "invalid-id"


